Index: /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation.cpp	(revision 1134)
@@ -473,6 +473,6 @@
 
   // Sending global index of grid source to corresponding process as well as the corresponding mask
-  std::vector<MPI_Request> requests;
-  std::vector<MPI_Status> status;
+  std::vector<ep_lib::MPI_Request> requests;
+  std::vector<ep_lib::MPI_Status> status;
   boost::unordered_map<int, unsigned char* > recvMaskDst;
   boost::unordered_map<int, unsigned long* > recvGlobalIndexSrc;
@@ -484,7 +484,7 @@
     recvGlobalIndexSrc[recvRank] = new unsigned long [recvSize];
 
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Irecv(recvGlobalIndexSrc[recvRank], recvSize, MPI_UNSIGNED_LONG, recvRank, 46, client->intraComm, &requests.back());
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Irecv(recvMaskDst[recvRank], recvSize, MPI_UNSIGNED_CHAR, recvRank, 47, client->intraComm, &requests.back());
   }
@@ -522,7 +522,7 @@
 
     // Send global index source and mask
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendGlobalIndexSrc[sendRank], sendSize, MPI_UNSIGNED_LONG, sendRank, 46, client->intraComm, &requests.back());
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Isend(sendMaskDst[sendRank], sendSize, MPI_UNSIGNED_CHAR, sendRank, 47, client->intraComm, &requests.back());
   }
@@ -532,6 +532,6 @@
 
   // Okie, now use the mask to identify which index source we need to send, then also signal the destination which masked index we will return
-  std::vector<MPI_Request>().swap(requests);
-  std::vector<MPI_Status>().swap(status);
+  std::vector<ep_lib::MPI_Request>().swap(requests);
+  std::vector<ep_lib::MPI_Status>().swap(status);
   // Okie, on destination side, we will wait for information of masked index of source
   for (std::map<int,int>::const_iterator itSend = sendRankSizeMap.begin(); itSend != sendRankSizeMap.end(); ++itSend)
@@ -540,5 +540,5 @@
     int recvSize = itSend->second;
 
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Irecv(sendMaskDst[recvRank], recvSize, MPI_UNSIGNED_CHAR, recvRank, 48, client->intraComm, &requests.back());
   }
@@ -577,5 +577,5 @@
 
     // Okie, now inform the destination which source index are masked
-    requests.push_back(MPI_Request());
+    requests.push_back(ep_lib::MPI_Request());
     MPI_Isend(recvMaskDst[recvRank], recvSize, MPI_UNSIGNED_CHAR, recvRank, 48, client->intraComm, &requests.back());
   }
Index: /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation_factory_impl.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation_factory_impl.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/grid_transformation_factory_impl.hpp	(revision 1134)
@@ -57,7 +57,10 @@
   typedef std::map<ETranformationType, CreateTransformationCallBack> CallBackMap;
   static CallBackMap* transformationCreationCallBacks_;
+  #pragma omp threadprivate(transformationCreationCallBacks_)
+  
   static bool registerTransformation(ETranformationType transType, CreateTransformationCallBack createFn);
   static bool unregisterTransformation(ETranformationType transType);
   static bool initializeTransformation_;
+  #pragma omp threadprivate(initializeTransformation_)
 };
 
@@ -79,4 +82,6 @@
                                                                                std::map<int, int>& elementPositionInGridDst2DomainPosition)
 {
+  if (0 == transformationCreationCallBacks_)
+    transformationCreationCallBacks_ = new CallBackMap();
   typename CallBackMap::const_iterator it = (*transformationCreationCallBacks_).find(transType);
   if ((*transformationCreationCallBacks_).end() == it)
Index: /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_extract_axis.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1134)
@@ -49,5 +49,5 @@
   StdString op = "extract";
   pos_ = algo->position;
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1134)
@@ -75,5 +75,5 @@
   }
   
-  if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
+  if ((*CReductionAlgorithm::ReductionOperations_ptr).end() == (*CReductionAlgorithm::ReductionOperations_ptr).find(op))
     ERROR("CScalarAlgorithmReduceAxis::CScalarAlgorithmReduceAxis(CAxis* axisDestination, CAxis* axisSource, CReduceAxisToScalar* algo)",
        << "Operation '" << op << "' not found. Please make sure to use a supported one"
@@ -81,5 +81,5 @@
        << "Scalar destination " << scalarDestination->getId());
 
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1134)
@@ -69,5 +69,5 @@
   }
   
-  if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
+  if ((*CReductionAlgorithm::ReductionOperations_ptr).end() == (*CReductionAlgorithm::ReductionOperations_ptr).find(op))
     ERROR("CScalarAlgorithmReduceDomain::CScalarAlgorithmReduceDomain(CDomain* domainDestination, CDomain* domainSource, CReduceDomainToScalar* algo)",
        << "Operation '" << op << "' not found. Please make sure to use a supported one"
@@ -75,5 +75,5 @@
        << "Scalar destination " << scalarDestination->getId());
 
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: /XIOS/dev/branch_yushan_merged/src/xios_server.f90
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/xios_server.f90	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/xios_server.f90	(revision 1134)
@@ -1,9 +1,15 @@
 PROGRAM server_main
   USE xios
+  USE mod_wait
   IMPLICIT NONE
   INCLUDE "mpif.h"
-  INTEGER :: ierr
-  
+  INTEGER :: ierr, th_level
+    
+    CALL MPI_INIT(ierr)
+    !CALL MPI_INIT_thread(3, th_level, ierr)
+    CALL init_wait
     CALL xios_init_server
+    
+    CALL MPI_FINALIZE(ierr)
 
   END PROGRAM server_main
